<template>
  <v-container>


     <v-card class="mt-3">
        <v-card-text class="secondary--text">
           <v-row>
               <v-col cols="9" class="pb-0">
                   <h3>{{prove.order}}-{{prove.name}}</h3>
               </v-col>
               <v-col cols="3" class="pb-0 d-flex justify-end">
                    <v-switch
                        v-model="completedProve"
                        hide-details
                        class="pt-0 mt-0"
                        :loading=loading
                        :disabled=disabled
                        @click="CompleteBtn()"
                    ></v-switch>
               </v-col>
           </v-row>
           <v-row >
             <v-col cols="12" class="pt-0 d-flex justify-end">
                    <h5 v-if="completedProve">Completada</h5>
                    <h5 v-else>No completada</h5>
               </v-col>
           </v-row>
            <!-- <div v-if="prove.pointsextra != 0">
            <v-row>
             <v-col cols="12" class="pb-0 d-flex justify-end">
                    <v-switch
                        v-model="bonus"
                        color="red"
                        hide-details
                        class="pt-0 mt-0"
                        @click="CompleteBtnExtra()"
                    ></v-switch>
               </v-col>
               <v-col cols="12" class="pt-0 d-flex justify-end">
                    <h4>Punts extra</h4>
               </v-col>

            </v-row>
          </div> -->
       </v-card-text>
       <v-img :src="prove.img" height="280"></v-img>
       <v-card-text class="secondary--text">
           <v-row>
               <v-col cols="12" class="text-justify">
                   <h3>{{prove.description}}</h3>
               </v-col>
           </v-row>
           <v-row>
               <v-col cols="8" class="text-left">
                   <h4>{{prove.fotovideo}} </h4>
               </v-col>
               <v-col cols="4" class="text-right">
                   <h4>{{prove.points}} punts </h4>
               </v-col>
           </v-row>

         
           
       </v-card-text>
       <v-card-text class="white--text">
        
           <!-- <v-row>
              <v-col cols="12" align="center" justify="space-around">
                    <v-btn class="mb-3 primary">
                      Penjar vídeo
                      <v-icon class="ml-3">mdi-cloud-upload</v-icon>
                    </v-btn>
               </v-col>
           </v-row> -->

       </v-card-text>

    </v-card>

    <div class="mt-3" align="left">
      <app-ui-back-btn></app-ui-back-btn>
    </div>

   </v-container>
</template>

<script>
export default {
   data () {
      return {
        completedProve: false,
        bonus: false,
        loading:false,
        disabled:false,
        switchBonus: false
      }
    },
  computed:{
    userCompleted(){
      return this.$store.getters['user/completed']
    },
  },
  async asyncData({ app, route }) {
    const client = app.apolloProvider.defaultClient;
    const id = route.params.prove;
    const query = {
      query: require("../../../graphql/prove.gql"),
      variables: { id },
    };
    let prove = null;
    await client
      .query(query)
      .then((data) => {
        prove = data.data.prove;
      })
      .catch((e) => console.log(e));

    return { prove };
  },
   methods:{
    proveIsCompleted(){
      if(this.userCompleted){
        const id = this.prove.id
          if(this.userCompleted.some((fav) => fav.id === id)){
            return true
          }
      }
      return false
    },

    CompleteBtn(){
      this.loadingdisabled()

      setTimeout(this.loadingdisabled, 1000);
      // this.completedProve = !this.completedProve
      if (this.completedProve) {
        this.proveCompleted()
        this.$store.dispatch("snackbars/setSnack", {text:'Prova completada - Puntuació afegida', color:'primary'})
      }else {
        this.proveUncompleted()
        this.$store.dispatch("snackbars/setSnack", {text:'Prova no completada - Puntuació restada', color:'error'})
      }
    },
    async CompleteBtnExtra(){
        // this.loadingdisabledExtra()

        // setTimeout(this.loadingdisabledExtra, 1000);
        if (this.prove.bonus==false) {
            const variables = {
              idUser:this.$auth.user.id,
              score:this.$auth.user.score + this.prove.pointsextra,
            }
            await this.$apollo.mutate({
              context:{
                headers:{
                  authorization:this.$auth.strategy.token.get()
                }
              },
              mutation:require("../../../graphql/updateTeam.gql"),
              variables:variables
            })
          
          await this.$auth.fetchUser()
          this.$store.dispatch("snackbars/setSnack", {text:'Punts extra afegits', color:'primary'})

        }else {
            // this.proveUncompleted()
            this.$store.dispatch("snackbars/setSnack", {text:'Punts extra restats', color:'error'})
          }
    },

    async proveCompleted(){
      // this.$store.commit("user/addProve", this.prove)
      

      let userComp = this.$store.getters['user/completedGQL']
      userComp.push(this.prove.id)

      const variables = {
        idUser:this.$auth.user.id,
        completed:userComp,
        score:this.$auth.user.score + this.prove.points
      }


      await this.$apollo.mutate({
        context:{
          headers:{
            authorization:this.$auth.strategy.token.get()
          }
        },
        mutation:require("../../../graphql/updateTeam.gql"),
        variables:variables
        
      })
    
     await this.$store.dispatch("user/getCompleted")


     await this.$auth.fetchUser()
    },
   
    async proveUncompleted(){

      let userComp = this.$store.getters['user/completedGQL']
      const index = userComp.indexOf(this.prove.id)
      userComp.splice(index, 1)

      const variables = {
        idUser:this.$auth.user.id,
        completed:userComp,
        score:this.$auth.user.score - this.prove.points
      }

      await this.$apollo.mutate({
        context:{
          headers:{
            authorization:this.$auth.strategy.token.get()
          }
        },
        mutation:require("../../../graphql/updateTeam.gql"),
        variables:variables
      })

      await this.$store.dispatch("user/getCompleted")
      // await this.$store.dispatch("refreshTeams") prueba git
      
      await this.$auth.fetchUser()
    },
    loadingdisabled(){
      if(this.loading){
        this.loading=false
      }else this.loading=true
      if(this.disabled){
        this.disabled=false
      }else this.disabled=true

    }
  },
  async mounted(){
      await this.$store.dispatch("user/getCompleted")
      this.completedProve = this.proveIsCompleted()
      this.bonus = this.prove.bonus
  }
};
</script>

<style scoped>

.container {
  background-image: url("https://i.ibb.co/5MTKvcz/Fons-Sense-Muntanya.png");
  background-size: cover;
  background-position: center;
  height: 100%;
}

  
</style>

